## libajantv2-dmo 17.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

# For CMAKE_MSVC_RUNTIME_LIBRARY compatability. Per note: This must be before the first project() 
if(POLICY CMP0091)
  cmake_policy(SET CMP0091 NEW)
endif()

project(libajantv2)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(LIBAJANTV2_CMAKE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")
list(APPEND CMAKE_MODULE_PATH "${LIBAJANTV2_CMAKE_DIR}")
list(REMOVE_DUPLICATES CMAKE_MODULE_PATH)

if (NOT AJANTV2_VERSION_FILENAME)
    set(AJANTV2_VERSION_FILENAME ${CMAKE_CURRENT_SOURCE_DIR}/VERSION.txt)
endif()

include(GNUInstallDirs)
include(CMakeOptions)
include(Defines)
include(Version)

if (CMAKE_SYSTEM_NAME STREQUAL "Windows")
	if (DEFINED AJA_MSVC_RUNTIME_LIBRARY)
		set(CMAKE_MSVC_RUNTIME_LIBRARY "${AJA_MSVC_RUNTIME_LIBRARY}" PARENT_SCOPE)
	endif()
endif()

option(AJANTV2_BUILD_OPENSOURCE    "Build libajantv2 as open-source (MIT license)?"   ON)
option(AJANTV2_BUILD_SHARED        "Build libajantv2 shared libraries?"               OFF)

option(AJANTV2_DISABLE_DEMOS       "Disable building libajantv2 demo apps?"           OFF)
option(AJANTV2_DISABLE_DRIVER      "Disable building libajantv2 driver (Linux-only)?" OFF)
option(AJANTV2_DISABLE_TESTS       "Disable building libajantv2 tests?"               OFF)
option(AJANTV2_DISABLE_TOOLS       "Disable building libajantv2 tools?"               OFF)
option(AJANTV2_DISABLE_PLUGIN_LOAD "Disable NTV2 3rd party plugin loading?"           OFF)
option(AJANTV2_DISABLE_RDMA        "Disable building with Nvidia RDMA?"               OFF)

if (NOT DEFINED LIBAJANTV2_DIR)
    set(LIBAJANTV2_DIR ${CMAKE_CURRENT_SOURCE_DIR})
endif()

if(NOT AJANTV2_BUILD_OPENSOURCE)
    if (NOT DEFINED LIBAJANTV2_PRIVATE_DIR)
        set(LIBAJANTV2_PRIVATE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../libajantv2-private)
    endif()
endif()

# Cascade top-level options
if(DEFINED BUILD_SHARED_LIBS)
    set(AJANTV2_BUILD_SHARED ${BUILD_SHARED_LIBS})
endif()
if(DEFINED AJA_BUILD_SHARED)
    set(AJANTV2_BUILD_SHARED ${AJA_BUILD_SHARED})
endif()
if(DEFINED AJA_DISABLE_DEMOS)
    set(AJANTV2_DISABLE_DEMOS ${AJA_DISABLE_DEMOS})
endif()
if (DEFINED AJA_DISABLE_DRIVER)
    set(AJANTV2_DISABLE_DRIVER ${AJA_DISABLE_DRIVER})
endif()
if(DEFINED AJA_DISABLE_TESTS)
	set(AJANTV2_DISABLE_TESTS ${AJA_DISABLE_TESTS})
endif()
if(DEFINED AJA_DISABLE_TOOLS)
    set(AJANTV2_DISABLE_TOOLS ${AJA_DISABLE_TOOLS})
endif()
if(DEFINED AJA_DISABLE_PLUGIN_LOAD)
    set(AJANTV2_DISABLE_PLUGIN_LOAD ${AJA_DISABLE_PLUGIN_LOAD})
endif()

add_subdirectory(ajantv2)
add_subdirectory(demos)
add_subdirectory(tools)
add_subdirectory(driver)

if(AJA_INSTALL_CMAKE)
    install(FILES CMakeLists.txt DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2)
endif()

if (NOT AJANTV2_DISABLE_TESTS)
    add_subdirectory(ajabase/test)
    add_subdirectory(ajaanc/test)
endif()

=== ajantv2/CMakeLists.txt ===
project(ajantv2)

include(CMakePackageConfigHelpers)
include(ExternalProject)

if (CMAKE_CXX_STANDARD EQUAL 98)
    message(STATUS "ajantv2 building for C++98")
    remove_definitions(
        -DAJA_USE_CPLUSPLUS11
        -DNTV2_USE_CPLUSPLUS11)

    set(_ajabase_types_path "../ajabase/common/types.h")
    file(READ ${_ajabase_types_path} _ajabase_types_file)
    STRING(REPLACE "#define AJA_USE_CPLUSPLUS11" "//#define AJA_USE_CPLUSPLUS11 " _ajabase_types_file "${_ajabase_types_file}")
    file(WRITE ${_ajabase_types_path} "${_ajabase_types_file}")
    message(STATUS "Overwrote ${_ajabase_types_path} to remove AJA_USE_CPLUSPLUS11 define!")

    set(_ajantv2_ajatypes_path "includes/ajatypes.h")
    file(READ ${_ajantv2_ajatypes_path} _ajatypes_file)
    STRING(REPLACE "#define NTV2_USE_CPLUSPLUS11" "//#define NTV2_USE_CPLUSPLUS11 " _ajatypes_file "${_ajatypes_file}")
    file(WRITE ${_ajantv2_ajatypes_path} "${_ajatypes_file}")
    message(STATUS "Overwrote ${_ajantv2_ajatypes_path} to remove NTV2_USE_CPLUSPLUS11 define!")
elseif(CMAKE_CXX_STANDARD GREATER_EQUAL 11)
    message(STATUS "ajantv2 building for C++11")
    list(APPEND TARGET_COMPILE_DEFS
        -DAJA_USE_CPLUSPLUS11
        -DNTV2_USE_CPLUSPLUS11)
else()
    message(FATAL_ERROR "Unsupported C++ standard! NTV2 requires C++98 or higher. CMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}")
endif()

remove_definitions(
    -DQT_LARGEFILE_SUPPORT)

set(TARGET_INCLUDE_DIRS
    ${LIBAJANTV2_DIR}
    ${LIBAJANTV2_DIR}/ajaanc/includes
    ${LIBAJANTV2_DIR}/ajabase
    ${LIBAJANTV2_DIR}/ajantv2/includes
    ${CMAKE_CURRENT_BINARY_DIR}
)

set(INSTALL_INCLUDE_DIRS
    ${CMAKE_INSTALL_INCLUDEDIR}/libajantv2
    ${CMAKE_INSTALL_INCLUDEDIR}/libajantv2/ajantv2/includes
)

if (AJANTV2_DISABLE_PLUGIN_LOAD)
    message(STATUS "NTV2 SDK will NOT load 3rd-party plugins")
    list(APPEND TARGET_COMPILE_DEFS
        -DNTV2_PREVENT_PLUGIN_LOAD)
else()
    if(NOT DEFINED AJANTV2_MBEDTLS_URL)
        set(AJANTV2_MBEDTLS_URL https://github.com/aja-video/mbedtls.git)
    endif()
    message(STATUS "NTV2 SDK will load signed 3rd-party plugins")

    set(MBEDTLS_INSTALL_DIR ${CMAKE_CURRENT_BINARY_DIR}/mbedtls-install)
    set(MBEDTLS_INCLUDE_DIR ${MBEDTLS_INSTALL_DIR}/include)
    set(MBEDTLS_LIBRARY_DIR ${MBEDTLS_INSTALL_DIR}/${CMAKE_INSTALL_LIBDIR})

    if(CMAKE_SYSTEM_NAME STREQUAL "Windows")
        set(MBEDTLS_LIBRARY ${MBEDTLS_LIBRARY_DIR}/mbedtls.lib)
        set(MBEDX509_LIBRARY ${MBEDTLS_LIBRARY_DIR}/mbedx509.lib)
        set(MBEDCRYPTO_LIBRARY ${MBEDTLS_LIBRARY_DIR}/mbedcrypto.lib)
        set(MBEDTLS_EXTRA_CONFIG_FLAGS
                "-DCMAKE_WINDOWS_EXPORT_ALL_SYMBOLS=ON"
                "-DCMAKE_MSVC_RUNTIME_LIBRARY=${CMAKE_MSVC_RUNTIME_LIBRARY}")
    elseif (CMAKE_SYSTEM_NAME MATCHES "^(Linux|Darwin)$")
        set(MBEDTLS_LIBRARY ${MBEDTLS_LIBRARY_DIR}/libmbedtls.a)
        set(MBEDX509_LIBRARY ${MBEDTLS_LIBRARY_DIR}/libmbedx509.a)
        set(MBEDCRYPTO_LIBRARY ${MBEDTLS_LIBRARY_DIR}/libmbedcrypto.a)
        set(MBEDTLS_C_FLAGS -fPIC)
    endif()

    # BUILD_BYPRODUCTS informing CMake where the .a files are located is required to make Ninja build work
    ExternalProject_Add(
        mbedtls
        GIT_REPOSITORY ${AJANTV2_MBEDTLS_URL}
        GIT_TAG fix-win-dll-cmake
        CMAKE_ARGS -DCMAKE_INSTALL_PREFIX=${MBEDTLS_INSTALL_DIR}
                    -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}
                    -DENABLE_TESTING=OFF 
                    -DENABLE_PROGRAMS=OFF
                    -DCMAKE_C_FLAGS=${MBEDTLS_C_FLAGS}
                    -DCMAKE_OSX_DEPLOYMENT_TARGET=${CMAKE_OSX_DEPLOYMENT_TARGET}
                    -DUSE_STATIC_MBEDTLS_LIBRARY=ON
                    -DUSE_SHARED_MBEDTLS_LIBRARY=OFF
                    ${MBEDTLS_EXTRA_CONFIG_FLAGS}
		CMAKE_CACHE_ARGS "-DCMAKE_OSX_ARCHITECTURES:STRING=${CMAKE_OSX_ARCHITECTURES}"
        BUILD_ALWAYS TRUE
        BUILD_BYPRODUCTS ${MBEDTLS_LIBRARY} ${MBEDX509_LIBRARY} ${MBEDCRYPTO_LIBRARY}
    )

    list(APPEND TARGET_INCLUDE_DIRS
            ${MBEDTLS_INCLUDE_DIR})
    list(APPEND MBEDTLS_LINK_LIBS
            ${MBEDTLS_LIBRARY}
            ${MBEDCRYPTO_LIBRARY}
            ${MBEDX509_LIBRARY})
endif()


# ajantv2
set(AJANTV2_HEADERS
    includes/ajaexport.h
    includes/ajatypes.h
    includes/basemachinecontrol.h
    includes/ntv2audiodefines.h
    includes/ntv2bft.h
    includes/ntv2bitfile.h
    includes/ntv2bitfilemanager.h
#   includes/ntv2boardfeatures.h	# removed in SDK 17.0
#   includes/ntv2boardscan.h		# removed in SDK 17.0
    includes/ntv2card.h
    includes/ntv2choosableboard.h
    includes/ntv2config2022.h
    includes/ntv2config2110.h
    includes/ntv2configts2022.h
    includes/ntv2cscmatrix.h
    includes/ntv2debug.h
    includes/ntv2debugmacros.h
    includes/ntv2devicecapabilities.h
    includes/ntv2devicefeatures.h
    includes/ntv2devicefeatures.hh # generated by sdkgen
    includes/ntv2devicescanner.h
#   includes/ntv2discover.h	# removed in SDK 17.0
    includes/ntv2driverinterface.h
    includes/ntv2endian.h
    includes/ntv2enhancedcsc.h
    includes/ntv2enums.h
    includes/ntv2fixed.h
    includes/ntv2formatdescriptor.h
    includes/ntv2konaflashprogram.h
    includes/ntv2m31enums.h
    includes/ntv2m31publicinterface.h
    includes/ntv2mailbox.h
    includes/ntv2mbcontroller.h
    includes/ntv2mcsfile.h
    includes/ntv2nubaccess.h
    includes/ntv2nubtypes.h
#   includes/ntv2nubpktcom.h	# removed in SDK 17.0
    includes/ntv2publicinterface.h
    includes/ntv2registerexpert.h
    includes/ntv2registers2022.h
    includes/ntv2registers2110.h
    includes/ntv2registersmb.h
    includes/ntv2resample.h
    includes/ntv2routingexpert.h
    includes/ntv2rp188.h
#   includes/ntv2rp215.h	# removed in SDK 17.0
    includes/ntv2serialcontrol.h
    includes/ntv2signalrouter.h
    includes/ntv2spiinterface.h
    includes/ntv2supportlogger.h
    includes/ntv2task.h
    includes/ntv2testpatterngen.h
    includes/ntv2transcode.h
    includes/ntv2tshelper.h
#   includes/ntv2utf8.h	# removed in SDK 17.1
    includes/ntv2utils.h
    includes/ntv2verticalfilter.h
    includes/ntv2videodefines.h
    includes/ntv2virtualregisters.h
    includes/ntv2vpid.h
    includes/ntv2vpidfromspec.h)
set(AJANTV2_SOURCES
    src/ntv2anc.cpp
    src/ntv2aux.cpp
    src/ntv2audio.cpp
    src/ntv2autocirculate.cpp
    src/ntv2bitfile.cpp
    src/ntv2bitfilemanager.cpp
    src/ntv2card.cpp
    src/ntv2config2022.cpp
    src/ntv2config2110.cpp
    src/ntv2configts2022.cpp
    src/ntv2csclut.cpp
    src/ntv2cscmatrix.cpp
    src/ntv2debug.cpp
    src/ntv2devicefeatures.cpp
    src/ntv2devicefeatures.hpp	# generated by sdkgen
    src/ntv2devicescanner.cpp
#   src/ntv2discover.cpp		# removed in SDK 17.0
    src/ntv2dma.cpp
    src/ntv2driverinterface.cpp
    src/ntv2dynamicdevice.cpp
    src/ntv2enhancedcsc.cpp
    src/ntv2formatdescriptor.cpp
    src/ntv2hdmi.cpp
    src/ntv2hevc.cpp
    src/ntv2interrupts.cpp
    src/ntv2konaflashprogram.cpp
    src/ntv2mailbox.cpp
    src/ntv2mbcontroller.cpp
    src/ntv2mcsfile.cpp
    src/ntv2nubaccess.cpp
#   src/ntv2nubpktcom.cpp		# removed in SDK 17.0
    src/ntv2publicinterface.cpp
    src/ntv2regconv.cpp			# added in SDK 17.0
    src/ntv2register.cpp
    src/ntv2registerexpert.cpp
    src/ntv2regroute.cpp		# added in SDK 17.0
    src/ntv2regvpid.cpp			# added in SDK 17.0
    src/ntv2resample.cpp
    src/ntv2routingexpert.cpp
    src/ntv2rp188.cpp
#   src/ntv2rp215.cpp			# removed in SDK 17.0
    src/ntv2serialcontrol.cpp
    src/ntv2signalrouter.cpp
    src/ntv2spiinterface.cpp
    src/ntv2stream.cpp
    src/ntv2subscriptions.cpp
    src/ntv2supportlogger.cpp
    src/ntv2task.cpp
    src/ntv2testpatterngen.cpp
    src/ntv2transcode.cpp
#   src/ntv2utf8.cpp			# removed in SDK 17.1
    src/ntv2utils.cpp
    src/ntv2version.cpp
    src/ntv2verticalfilter.cpp
    src/ntv2vpid.cpp
    src/ntv2vpidfromspec.cpp)
# ntv2driverinterface/publicinterface
set(AJANTV2_WIN_HEADERS
    src/win/ntv2windriverinterface.h
    src/win/ntv2winpublicinterface.h)
set(AJANTV2_WIN_SOURCES
    # src/win/dllmain.cpp
    src/win/ntv2windriverinterface.cpp)
set(AJANTV2_MAC_HEADERS
    src/mac/ntv2macdriverinterface.h
    src/mac/ntv2macpublicinterface.h)
set(AJANTV2_MAC_SOURCES
    src/mac/ntv2macdriverinterface.cpp)
set(AJANTV2_LIN_HEADERS
    src/lin/ntv2linuxdriverinterface.h
    src/lin/ntv2linuxpublicinterface.h)
set(AJANTV2_LIN_SOURCES
    src/lin/ntv2linuxdriverinterface.cpp)
set(AJANTV2_BM_HEADERS
    src/bm/ntv2baremetaldriverinterface.h
    src/bm/ntv2baremetalpublicinterface.h)
set(AJANTV2_BM_SOURCES
    src/bm/ntv2baremetaldriverinterface.cpp)
# ajantv2 utilityfiles
set(AJANTV2_UTILITY_PUBLIC_HEADERS
    utilityfiles/public/ntv2firmwareinstallerthread.h
    utilityfiles/public/ntv2hevcfirmwareinstallerthread.h)
set(AJANTV2_UTILITY_PUBLIC_SOURCES
    utilityfiles/public/ntv2firmwareinstallerthread.cpp
    utilityfiles/public/ntv2hevcfirmwareinstallerthread.cpp)

if (NOT AJANTV2_BUILD_OPENSOURCE)
    # ajantv2 hevc codec sources
    if (EXISTS ${LIBAJANTV2_PRIVATE_DIR})
        set(AJANTV2_HEVC_HEADERS
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31.h
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31cparam.h
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31ehparam.h
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31vaparam.h
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31vinparam.h
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31viparam.h)
        set(AJANTV2_HEVC_SOURCES
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31.cpp
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31cparam.cpp
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31ehparam.cpp
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31vaparam.cpp
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31vinparam.cpp
            ${LIBAJANTV2_PRIVATE_DIR}/codecs/hevc/m31/ntv2m31viparam.cpp)
        # `cmake --install` deployments
        if (AJA_INSTALL_HEADERS)
            install(FILES ${AJANTV2_HEVC_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libajantv2/ajantv2/codecs/hevc/m31)
        endif()
        if (AJA_INSTALL_SOURCES)
            install(FILES ${AJANTV2_HEVC_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/ajantv2/codecs/hevc/m31)
        endif()
        message(STATUS "added ajantv2 HEVC/M31 codec sources from ${LIBAJANTV2_PRIVATE_DIR}")
    else()
        message(STATUS "ajantv2 private repo sources not found: ${LIBAJANTV2_PRIVATE_DIR}")
    endif()
endif()

configure_file(includes/ntv2version.h.in includes/ntv2version.h @ONLY)
configure_file(includes/ntv2version.h.in ${CMAKE_CURRENT_SOURCE_DIR}/includes/ntv2version.h @ONLY)

# ajaanc
set(AJAANC_HEADERS
    ../ajaanc/includes/ancillarydata.h
    ../ajaanc/includes/ancillarydatafactory.h
    ../ajaanc/includes/ancillarydata_cea608.h
    ../ajaanc/includes/ancillarydata_cea608_line21.h
    ../ajaanc/includes/ancillarydata_cea608_vanc.h
    ../ajaanc/includes/ancillarydata_cea708.h
    ../ajaanc/includes/ancillarydata_framestatusinfo524D.h
    ../ajaanc/includes/ancillarydata_framestatusinfo5251.h
    ../ajaanc/includes/ancillarydata_hdr_hdr10.h
    ../ajaanc/includes/ancillarydata_hdr_hlg.h
    ../ajaanc/includes/ancillarydata_hdr_sdr.h
    ../ajaanc/includes/ancillarydata_timecode.h
    ../ajaanc/includes/ancillarydata_timecode_atc.h
    ../ajaanc/includes/ancillarydata_timecode_vitc.h
    ../ajaanc/includes/ancillarydata_hdmi_aux.h
    ../ajaanc/includes/ancillarylist.h)
set(AJAANC_SOURCES
    ../ajaanc/src/ancillarydata.cpp
    ../ajaanc/src/ancillarydatafactory.cpp
    ../ajaanc/src/ancillarydata_cea608.cpp
    ../ajaanc/src/ancillarydata_cea608_line21.cpp
    ../ajaanc/src/ancillarydata_cea608_vanc.cpp
    ../ajaanc/src/ancillarydata_cea708.cpp
    ../ajaanc/src/ancillarydata_framestatusinfo524D.cpp
    ../ajaanc/src/ancillarydata_framestatusinfo5251.cpp
    ../ajaanc/src/ancillarydata_hdr_hdr10.cpp

=== demos/CMakeLists.txt ===
if (AJANTV2_DISABLE_DEMOS)
    message(STATUS "Skipping libajantv2 demos...")
    return()
endif()

add_subdirectory(ntv2burn)
add_subdirectory(ntv2burn4kquadrant)
add_subdirectory(ntv2capture)
add_subdirectory(ntv2capture4k)
add_subdirectory(ntv2capture8k)
add_subdirectory(ntv2dolbycapture)
add_subdirectory(ntv2dolbyplayer)
# add_subdirectory(ntv2encodehevc) # requires HEVC codecs
# add_subdirectory(ntv2encodehevcfile) # requires HEVC codecs
# add_subdirectory(ntv2encodehevcvif) # requires HEVC codecs
add_subdirectory(ntv2enumerateboards)
add_subdirectory(ntv2fieldburn)
add_subdirectory(ntv2hdrsetup)
if(NOT AJA_DISABLE_QT)
    add_subdirectory(ntv2qtpreview)
    add_subdirectory(ntv2streampreview)
    add_subdirectory(ntv2qtmultiinput)
    add_subdirectory(ntv2konaipj2ksetup)
    add_subdirectory(ntv2konaipjsonsetup)
endif()

add_subdirectory(ntv2llburn)
add_subdirectory(ntv2outputtestpattern)
add_subdirectory(ntv2overlay)
add_subdirectory(ntv2player)
add_subdirectory(ntv2player4k)
add_subdirectory(ntv2player8k)
add_subdirectory(ntv2streamplayer)
add_subdirectory(ntv2switchbitfile)

if(NOT AJANTV2_BUILD_OPENSOURCE)
    add_subdirectory(ntv2ccgrabber)  
    add_subdirectory(ntv2ccplayer)
endif()

if (NOT AJA_DISABLE_AMD)
    add_subdirectory(AMD)
endif()

if (NOT AJA_DISABLE_NVIDIA)
    add_subdirectory(NVIDIA)
    message(STATUS "Adding NVIDIA demos...")
endif()

if(AJA_INSTALL_CMAKE)
    install(FILES CMakeLists.txt DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/demos)
endif()

=== ajantv2/build/Makefile ===
# SPDX-License-Identifier: MIT
#
# Copyright (C) 2004 - 2022 AJA Video Systems, Inc.
#

DIR := $(strip $(shell dirname $(abspath $(lastword $(MAKEFILE_LIST)))))

ifeq (,$(filter _%,$(notdir $(CURDIR))))
  include $(DIR)/../../../build/targets.mk
else
include $(DIR)/../../../build/configure.mk

ifeq ($(AJA_DEBUG),1)
	AJA_LIB = ajantv2d
else
	AJA_LIB = ajantv2
endif
AJA_LIB_PATH = $(A_UBER_LIB)/lib$(AJA_LIB).a
#AJA_LIB_PATH_SO = $(A_UBER_LIB)/lib$(AJA_LIB).so

KERNEL_INCLUDES	:= /lib/modules/$(shell uname -r)/build

VPATH := $(A_LIB_NTV2_SRC):$(A_LIB_NTV2_SRC_LINUX):$(A_LIB_NTV2_M31_PATH):$(A_LIB_NTV2_INC):$(A_LIB_ANC_PATH)/src:$(A_LIB_BASE_PATH):$(A_LIB_BASE_PATH)/common:$(A_LIB_BASE_PATH)/system:$(A_LIB_BASE_PATH)/system/linux:$(A_LIB_BASE_PATH)/pnp:$(A_LIB_BASE_PATH)/pnp/linux:$(A_LIB_BASE_PATH)/persistence:$(A_LIB_BASE_PATH)/network:$(KERNEL_INCLUDES):$(SRCDIR)

CPPFLAGS := -D_REENTRANT -DAJASTATIC

INCLUDES = -I$(KERNEL_INCLUDES) -I$(A_LIB_ANC_PATH)/includes

AJA_LIB_SRCS =\
		ancillarydata.cpp \
		ancillarydatafactory.cpp \
		ancillarydata_cea608.cpp \
		ancillarydata_cea608_line21.cpp \
		ancillarydata_cea608_vanc.cpp \
		ancillarydata_cea708.cpp \
		ancillarydata_framestatusinfo524D.cpp \
		ancillarydata_framestatusinfo5251.cpp \
		ancillarydata_hdr_hdr10.cpp \
		ancillarydata_hdr_hlg.cpp \
		ancillarydata_hdr_sdr.cpp \
		ancillarydata_timecode.cpp \
		ancillarydata_timecode_atc.cpp \
		ancillarydata_timecode_vitc.cpp \
		ancillarylist.cpp \
		atomic.cpp \
	    audioutilities.cpp \
		buffer.cpp \
		commandline.cpp \
		common.cpp \
		debug.cpp \
		dpx_hdr.cpp \
		dpxfileio.cpp \
		event.cpp \
		eventimpl.cpp \
		file_io.cpp \
		guid.cpp \
		info.cpp \
		infoimpl.cpp \
		ip_socket.cpp \
		lock.cpp \
		lockimpl.cpp \
		memory.cpp \
		options_popt.cpp \
		performance.cpp \
		pixelformat.cpp \
		pnp.cpp \
		pnpimpl.cpp \
		process.cpp \
		processimpl.cpp \
		system.cpp \
		systemtime.cpp \
		testpatterngen.cpp \
		thread.cpp \
		threadimpl.cpp \
		timebase.cpp \
		timecode.cpp \
		timecodeburn.cpp \
		timer.cpp \
		udp_socket.cpp \
		variant.cpp \
		videoutilities.cpp \
		wavewriter.cpp \
		ntv2audio.cpp \
		ntv2anc.cpp \
		ntv2autocirculate.cpp \
		ntv2bitfile.cpp \
		ntv2bitfilemanager.cpp \
		ntv2card.cpp \
		ntv2config2022.cpp \
		ntv2config2110.cpp \
		ntv2configts2022.cpp \
		ntv2csclut.cpp \
		ntv2cscmatrix.cpp \
		ntv2debug.cpp \
		ntv2devicefeatures.cpp \
		ntv2devicescanner.cpp \
		ntv2dma.cpp \
		ntv2dynamicdevice.cpp \
		ntv2hdmi.cpp \
		ntv2hevc.cpp \
		ntv2driverinterface.cpp \
		ntv2enhancedcsc.cpp \
		ntv2formatdescriptor.cpp \
		ntv2interrupts.cpp \
		ntv2konaflashprogram.cpp \
		ntv2linuxdriverinterface.cpp \
		ntv2mailbox.cpp \
		ntv2mbcontroller.cpp \
		ntv2mcsfile.cpp \
		ntv2nubaccess.cpp \
		ntv2publicinterface.cpp \
		ntv2register.cpp \
		ntv2registerexpert.cpp \
		ntv2resample.cpp \
		ntv2routingexpert.cpp \
		ntv2rp188.cpp \
		ntv2serialcontrol.cpp \
		ntv2signalrouter.cpp \
		ntv2spiinterface.cpp \
		ntv2subscriptions.cpp \
		ntv2supportlogger.cpp \
		ntv2transcode.cpp \
		ntv2utf8.cpp \
		ntv2utils.cpp \
		ntv2version.cpp \
		ntv2verticalfilter.cpp \
		ntv2vpid.cpp \
		ntv2vpidfromspec.cpp \
		ntv2task.cpp \
		ntv2testpatterngen.cpp \
        ntv2m31.cpp \
        ntv2m31cparam.cpp \
        ntv2m31ehparam.cpp \
        ntv2m31vaparam.cpp \
        ntv2m31vinparam.cpp \
        ntv2m31viparam.cpp 

ifndef AJA_LIB_PATH_SO
	AJA_LIB_SRCS += persistence.cpp
endif

include $(DIR)/../../../build/common.mk

endif

=== demos/AMD/CMakeLists.txt ===
message(STATUS "AMD demos not yet implemented")
return()

=== demos/ntv2burn4kquadrant/CMakeLists.txt ===
project(ntv2burn4kquadrant)

set(TARGET_INCLUDE_DIRS
	${CMAKE_CURRENT_SOURCE_DIR}/../
	${CMAKE_CURRENT_SOURCE_DIR}/../../
	${CMAKE_CURRENT_SOURCE_DIR}/../../ajantv2/includes)

if (CMAKE_SYSTEM_NAME STREQUAL "Windows")
	# noop
elseif (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
	find_library(FOUNDATION_FRAMEWORK Foundation)
	set(TARGET_LINK_LIBS ${FOUNDATION_FRAMEWORK})
elseif (CMAKE_SYSTEM_NAME STREQUAL "Linux")
	set(TARGET_LINK_LIBS dl pthread rt)
endif()

set(DEMO_APP_SOURCES
	ntv2burn4kquadrant.h
	ntv2burn4kquadrant.cpp
	main.cpp
)
set(DEMO_COMMON_SOURCES
	${CMAKE_CURRENT_SOURCE_DIR}/../ntv2democommon.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/../ntv2democommon.h
)
set(TARGET_SOURCES
	${DEMO_APP_SOURCES}
	${DEMO_COMMON_SOURCES}
)

add_executable(${PROJECT_NAME} ${TARGET_SOURCES})
target_include_directories(${PROJECT_NAME} PUBLIC ${TARGET_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME} PUBLIC ${TARGET_LINK_LIBS} ajantv2)

if (AJA_CODE_SIGN)
    aja_code_sign(${PROJECT_NAME})
endif()

install(TARGETS ${PROJECT_NAME}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	FRAMEWORK DESTINATION ${CMAKE_INSTALL_LIBDIR}
	PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
if (AJA_INSTALL_SOURCES)
	install(FILES ${DEMO_COMMON_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/demos)
	install(FILES ${DEMO_APP_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/demos/ntv2burn4kquadrant)
endif()
if (AJA_INSTALL_CMAKE)
	install(FILES CMakeLists.txt DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/demos/ntv2burn4kquadrant)
endif()
if (AJA_INSTALL_MISC)
	install(FILES Makefile DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/demos/ntv2burn4kquadrant)
endif()

=== demos/ntv2burn4kquadrant/Makefile ===
# SPDX-License-Identifier: MIT
#
# Copyright (C) 2004 - 2022 AJA Video Systems, Inc.
#

DIR := $(strip $(shell dirname $(abspath $(lastword $(MAKEFILE_LIST)))))

ifeq (,$(filter _%,$(notdir $(CURDIR))))
  include $(DIR)/../../../../build/targets.mk
else
include $(DIR)/../../../../build/configure.mk

AJA_APP = $(A_UBER_BIN)/ntv2burn4kquadrant

VPATH	 = $(A_DEMOAPPS_PATH)
INCLUDES = -I$(A_DEMOAPPS_PATH)

SRCS = main.cpp ntv2burn4kquadrant.cpp ntv2democommon.cpp

INCS = ntv2burn4kquandrant.h ntv2democommon.h

include $(DIR)/../../../../build/common.mk

endif

=== demos/ntv2capture4k/CMakeLists.txt ===
project(ntv2capture4k)

set(TARGET_INCLUDE_DIRS
	${CMAKE_CURRENT_SOURCE_DIR}/../
	${CMAKE_CURRENT_SOURCE_DIR}/../../
	${CMAKE_CURRENT_SOURCE_DIR}/../../ajantv2/includes)

if (CMAKE_SYSTEM_NAME STREQUAL "Windows")
	# noop
elseif (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
	find_library(FOUNDATION_FRAMEWORK Foundation)
	set(TARGET_LINK_LIBS ${FOUNDATION_FRAMEWORK})
elseif (CMAKE_SYSTEM_NAME STREQUAL "Linux")
	set(TARGET_LINK_LIBS dl pthread rt)
endif()

set(DEMO_APP_SOURCES
	ntv2capture4k.h
	ntv2capture4k.cpp
	main.cpp
)
set(DEMO_COMMON_SOURCES
	${CMAKE_CURRENT_SOURCE_DIR}/../ntv2democommon.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/../ntv2democommon.h
)
set(TARGET_SOURCES
	${DEMO_APP_SOURCES}
	${DEMO_COMMON_SOURCES}
)

add_executable(${PROJECT_NAME} ${TARGET_SOURCES})
target_include_directories(${PROJECT_NAME} PUBLIC ${TARGET_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME} PUBLIC ${TARGET_LINK_LIBS} ajantv2)

if (AJA_CODE_SIGN)
    aja_code_sign(${PROJECT_NAME})
endif()

install(TARGETS ${PROJECT_NAME}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	FRAMEWORK DESTINATION ${CMAKE_INSTALL_LIBDIR}
	PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
if (AJA_INSTALL_SOURCES)
	install(FILES ${DEMO_COMMON_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/demos)
	install(FILES ${DEMO_APP_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/demos/ntv2capture4k)
endif()
if (AJA_INSTALL_CMAKE)
	install(FILES CMakeLists.txt DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/demos/ntv2capture4k)
endif()
if (AJA_INSTALL_MISC)
	install(FILES Makefile DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/demos/ntv2capture4k)
endif()

=== demos/ntv2capture8k/Makefile ===
# SPDX-License-Identifier: MIT
#
# Copyright (C) 2004 - 2022 AJA Video Systems, Inc.
#

DIR := $(strip $(shell dirname $(abspath $(lastword $(MAKEFILE_LIST)))))

ifeq (,$(filter _%,$(notdir $(CURDIR))))
  include $(DIR)/../../../../build/targets.mk
else
include $(DIR)/../../../../build/configure.mk

AJA_APP = $(A_UBER_BIN)/ntv2capture8k

VPATH	 = $(A_DEMOAPPS_PATH)
INCLUDES = -I$(A_DEMOAPPS_PATH)

SRCS = main.cpp ntv2capture8k.cpp ntv2democommon.cpp

INCS = ntv2capture8k.h ntv2democommon.h

include $(DIR)/../../../../build/common.mk

endif

=== demos/ntv2ccgrabber/CMakeLists.txt ===
project(ntv2ccgrabber)

set(TARGET_INCLUDE_DIRS
	${AJA_LIBRARIES_ROOT}
	${CMAKE_CURRENT_SOURCE_DIR}/../
	${AJA_LIB_NTV2_ROOT}/includes
	${AJA_LIB_RETAIL_ROOT}/includes
	${AJA_LIB_RETAIL_ROOT}/services
    ${LIBAJACC_DIR}/includes)

set(NTV2CCGRABBER_HEADERS
	ntv2ccgrabber.h)
set(NTV2CCGRABBER_SOURCES
	ntv2ccgrabber.cpp
	main.cpp)

set(DEMO_APPS_SOURCES
	${CMAKE_CURRENT_SOURCE_DIR}/../ntv2democommon.cpp)
set(DEMO_APPS_HEADERS
	${CMAKE_CURRENT_SOURCE_DIR}/../ntv2democommon.h)

if (CMAKE_SYSTEM_NAME STREQUAL "Windows")
	# noop
elseif (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
    find_library(FOUNDATION_FRAMEWORK Foundation)
    set(TARGET_LINK_LIBS ${FOUNDATION_FRAMEWORK})
elseif (CMAKE_SYSTEM_NAME STREQUAL "Linux")
	set(TARGET_LINK_LIBS dl pthread rt)
endif()

set(TARGET_SOURCES
	${NTV2CCGRABBER_SOURCES}
	${NTV2CCGRABBER_HEADERS}
	${DEMO_APPS_SOURCES}
	${DEMO_APPS_HEADERS})

add_executable(${PROJECT_NAME} ${TARGET_SOURCES})
target_include_directories(${PROJECT_NAME} PUBLIC ${TARGET_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME} PUBLIC ${TARGET_LINK_LIBS} ajacc ajantv2)

if (AJA_CODE_SIGN)
    aja_code_sign(${PROJECT_NAME})
endif()

install(TARGETS ${PROJECT_NAME}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	FRAMEWORK DESTINATION ${CMAKE_INSTALL_LIBDIR}
	PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
if (AJA_INSTALL_SOURCES)
	install(FILES ${DEMO_APPS_HEADERS} DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/demos)
	install(FILES ${DEMO_APPS_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/demos)
	install(FILES ${NTV2CCGRABBER_HEADERS} DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/demos/ntv2ccgrabber)
	install(FILES ${NTV2CCGRABBER_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/demos/ntv2ccgrabber)
endif()
if (AJA_INSTALL_CMAKE)
	install(FILES CMakeLists.txt DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/demos/ntv2ccgrabber)
endif()
if (AJA_INSTALL_MISC)
	install(FILES Makefile DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/demos/ntv2ccgrabber)
endif()

=== demos/ntv2ccplayer/CMakeLists.txt ===
project(ntv2ccplayer)

set(TARGET_INCLUDE_DIRS
	${AJA_LIBRARIES_ROOT}
	${CMAKE_CURRENT_SOURCE_DIR}/../
	${AJA_LIB_NTV2_ROOT}/includes
	${AJA_LIB_RETAIL_ROOT}/includes
	${AJA_LIB_RETAIL_ROOT}/services)

set(NTV2CCPLAYER_HEADERS
	ntv2ccplayer.h)
set(NTV2CCPLAYER_SOURCES
	ntv2ccplayer.cpp
	main.cpp)

set(DEMO_APPS_SOURCES
	${CMAKE_CURRENT_SOURCE_DIR}/../ntv2democommon.cpp)
set(DEMO_APPS_HEADERS
	${CMAKE_CURRENT_SOURCE_DIR}/../ntv2democommon.h)

if (CMAKE_SYSTEM_NAME STREQUAL "Windows")
	# noop
elseif (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
	find_library(FOUNDATION_FRAMEWORK Foundation)
	set(TARGET_LINK_LIBS ${FOUNDATION_FRAMEWORK})
elseif (CMAKE_SYSTEM_NAME STREQUAL "Linux")
	set(TARGET_LINK_LIBS dl pthread rt)
endif()

set(TARGET_SOURCES
	${NTV2CCPLAYER_SOURCES}
	${NTV2CCPLAYER_HEADERS}
	${DEMO_APPS_SOURCES}
	${DEMO_APPS_HEADERS})

add_executable(${PROJECT_NAME} ${TARGET_SOURCES})
target_include_directories(${PROJECT_NAME} PUBLIC ${TARGET_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME} PUBLIC ${TARGET_LINK_LIBS} ajacc ajantv2)

if (AJA_CODE_SIGN)
    aja_code_sign(${PROJECT_NAME})
endif()

install(TARGETS ${PROJECT_NAME}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	FRAMEWORK DESTINATION ${CMAKE_INSTALL_LIBDIR}
	PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
if (AJA_INSTALL_SOURCES)
	install(FILES ${DEMO_APPS_HEADERS} DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/demos)
	install(FILES ${DEMO_APPS_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/demos)
	install(FILES ${NTV2CCPLAYER_HEADERS} DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/demos/ntv2ccplayer)
	install(FILES ${NTV2CCPLAYER_SOURCES} DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/demos/ntv2ccplayer)
endif()
if (AJA_INSTALL_CMAKE)
	install(FILES CMakeLists.txt DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/demos/ntv2ccplayer)
endif()
if (AJA_INSTALL_MISC)
	install(FILES Makefile DESTINATION ${CMAKE_INSTALL_PREFIX}/libajantv2/demos/ntv2ccplayer)
endif()

=== demos/ntv2dolbyplayer/Makefile ===
# SPDX-License-Identifier: MIT
#
# Copyright (C) 2004 - 2022 AJA Video Systems, Inc.
#

DIR := $(strip $(shell dirname $(abspath $(lastword $(MAKEFILE_LIST)))))

ifeq (,$(filter _%,$(notdir $(CURDIR))))
  include $(DIR)/../../../../build/targets.mk
else
include $(DIR)/../../../../build/configure.mk

AJA_APP = $(A_UBER_BIN)/ntv2dolbyplayer

VPATH	 = $(A_DEMOAPPS_PATH)
INCLUDES = -I$(A_DEMOAPPS_PATH)

SRCS = main.cpp ntv2dolbyplayer.cpp ntv2democommon.cpp

INCS = ntv2dolbyplayer.h ntv2democommon.h

include $(DIR)/../../../../build/common.mk

endif

=== debian/changelog ===
libajantv2-dmo (17.5.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 08 Apr 2025 08:50:56 +0200

libajantv2-dmo (17.1.3-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 17 Dec 2024 01:43:10 +0100

libajantv2-dmo (17.1.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 25 Jul 2024 01:18:03 +0200

libajantv2-dmo (17.0.1-dmo1) unstable; urgency=medium

  * Initial release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 14 Jun 2024 15:19:33 +0200

=== debian/control ===
Source: libajantv2-dmo
Section: libdevel
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://github.com/aja-video/libajantv2
Standards-Version: 4.7.2
Build-Depends: debhelper-compat (= 13), cmake, ninja-build, libudev-dev,

Package: libajantv2-dev
Architecture: any
Multi-Arch: same
#Depends: libajantv2-17 (= ${binary:Version}), ${misc:Depends},
Depends: ${misc:Depends},
Description: Open-source library for AJA Video Systems desktop IO cards.
 This is the open-source SDK for discovering, interrogating and controlling
 NTV2 professional video I/O devices from AJA Video Systems, Inc. All code
 herein is licensed under the MIT license.

#Package: libajantv2-17
#Architecture: any
#Multi-Arch: same
#Depends: ${shlibs:Depends}, ${misc:Depends},
#Description: Open-source library for AJA Video Systems desktop IO cards.
# This is the open-source SDK for discovering, interrogating and controlling
# NTV2 professional video I/O devices from AJA Video Systems, Inc. All code
# herein is licensed under the MIT license.

=== debian/watch ===
version=4

#opts="uversionmangle=s/_/\./" \
#https://github.com/aja-video/libajantv2/tags \
#s%(?:.*?)?ntv2?(\d[\d.]*)@ARCHIVE_EXT@

#https://github.com/aja-video/libajantv2/archive/refs/tags/ntv2_17_0_1.tar.gz
